config/routes.rb
Rails.application.routes.draw do
  resources :strength_trainings
  resources :endurance_trainings
  resources :strength_trainings
  resources :endurance_trainings
  resources :strength_trainings
  resources :strength_trainings
  resources :endurance_trainings
  resources :trainings
  resources :statistic_entries
  resources :training_days
  resources :users

  get 'weekoverview/index'
  post '/weekoverview/index', to: 'weekoverview#index'

  get 'trainings/new/:date', to: 'trainings#new'

  get 'statistic_entries/new/:date', to: 'statistic_entries#new'

  get 'sessions/new'
  get    'help'    => 'static_pages#help'
  get    'about'   => 'static_pages#about'
  get    'contact' => 'static_pages#contact'
  get    'signup'  => 'users#new'
  get    'login'   => 'sessions#new'
  post   'login'   => 'sessions#create'
  delete 'logout'  => 'sessions#destroy'

  root :to => 'sessions#new'

end

app/models/user.rb
class User < ActiveRecord::Base
  has_one :training_day
  has_secure_password
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]
  skip_before_filter :check_session, :only=> [:new, :create]

  include SessionsHelper

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        log_in(@user)
        format.html { redirect_to @user, notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(:firstName, :lastName, :emailAddress, :userName, :birthday, :password, :password_confirmation)
    end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<%= form_for(@user) do |f| %>
  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% @user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :firstName %><br>
    <%= f.text_field :firstName %>
  </div>
  <div class="field">
    <%= f.label :lastName %><br>
    <%= f.text_field :lastName %>
  </div>
  <div class="field">
    <%= f.label :emailAddress %><br>
    <%= f.text_field :emailAddress %>
  </div>
  <div class="field">
    <%= f.label :userName %><br>
    <%= f.text_field :userName %>
  </div>
  <div class="field">
    <%= f.label :birthday %><br>
    <%= f.date_select :birthday %>
  </div>
  <div class="actions">
    <%= f.submit :class => 'btn btn-primary'%>
  </div>
<% end %>

app/views/users/edit.html.erb
<%= render "layouts/header" %>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <h1>Editing User</h1>

    <%= render 'form' %>

    <%= link_to 'Show', @user , :class => 'btn btn-info' %>
    <%= link_to 'Back', user_path(@user) , :class => 'btn btn-info' %>

  </div>
</div>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Users</h1>

<table>
  <thead>
    <tr>
      <th>Firstname</th>
      <th>Lastname</th>
      <th>Emailaddress</th>
      <th>Username</th>
      <th>Birthday</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.firstName %></td>
        <td><%= user.lastName %></td>
        <td><%= user.emailAddress %></td>
        <td><%= user.userName %></td>
        <td><%= user.birthday %></td>
        <td><%= link_to 'Show', user %></td>
        <td><%= link_to 'Edit', edit_user_path(user) %></td>
        <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User', new_user_path %>

app/views/users/new.html.erb
<% provide(:title, 'Sign up') %>
<%= render "layouts/header" %>

<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <h1>Sign up</h1>
    <%= form_for(@user) do |f| %>
        <%= render 'shared/error_messages' %>

        <%= f.label :userName %>
        <%= f.text_field :userName, class: 'form-control' %>

        <%= f.label :emailAddress %>
        <%= f.email_field :emailAddress, class: 'form-control' %>

        <%= f.label :firstName %>
        <%= f.text_field :firstName, class: 'form-control' %>

        <%= f.label :lastName %>
        <%= f.text_field :lastName, class: 'form-control' %>

        <%= f.label :password %>
        <%= f.password_field :password, class: 'form-control' %>

        <%= f.label :password_confirmation, "Confirmation" %>
        <%= f.password_field :password_confirmation, class: 'form-control' %>

        <%= f.submit "Create my account", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/users/show.html.erb
<%= render "layouts/header" %>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <h1><%= @user.userName %></h1>
    <p>
      <strong>Firstname:</strong>
      <%= @user.firstName %>
    </p>

    <p>
      <strong>Lastname:</strong>
      <%= @user.lastName %>
    </p>

    <p>
      <strong>Emailaddress:</strong>
      <%= @user.emailAddress %>
    </p>

    <p>
      <strong>Birthday:</strong>
      <%= @user.birthday %>
    </p>
    <%= link_to 'Edit', edit_user_path(@user) , :class => 'btn btn-info' %>
    <%= link_to 'Back', weekoverview_index_path , :class => 'btn btn-info' %>
  </div>
</div>